; CC2Net.de - Systemtreiber 0002
; (c) by Andr Helbig
; Release: 17.02.2005
; sys0002.asm Version 1.01
; -mem.c2-Routinen
; -strx.c2-Routinen
; -hwcom.receive()-Routinen
; -swcom.receive()-Routinen

$segmented
$model(medium)
$extend
$nomod166
$stdnames(reg164ci.def)
$NOLOCALS

	regdef	R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15
;**************************************************************************************************************

; P1L.0 CC60IO 
; P1L.1 COUT60
; P1L.2 CC61IO
; P1L.3 COUT61
; P1L.4 CC62IO
; P1L.5 COUT62
; P1L.6 COUT63
; P1L.7 CTRAP 
; P1H.0 CC6POS0
; P1H.1 CC6POS1
; P1H.2 CC6POS2
; P1H.3 T7IN   
; P1H.4 CC24IO 
; P1H.5 CC25IO
; P1H.6 CC26IO
; P1H.7 CC27IO


; Definition der OS-Routinen
OSsegment	EQU	0
POP_R4		EQU	0765AH	;uses: R4, R12, R13, R14
PUSH_R12	EQU	075D6H	;uses: R1, R2, R12, R13,R14,R15
POP_LONG	EQU	07680H  ;return in R4, R5
PUSH_LONG	EQU	075fEH  ;Value in R12, R13


userseg		SECTION CODE word at 3E1A0h
assume	dpp3:userseg


;************************************************************************************************************


;******************************************************
;hwcom.c2 & swcom.c2
;******************************************************
comget	proc near
	; uses R1, R2, R3, R4, R6, R8, R12, R13, R14, R15
	;R12=0 :hwcom. R12=0x36 :swcom
	MOV     R13, #0F938h
	ADD     R13, R12
	MOV     R14, R13
	ADD     R14 ,#02Ah
	MOV     R1 ,[R14]
	JMPR    cc_Z, hw_1 ; jmp if no Data
	MOV     R15, R13
	ADD     R15, #028h
	MOV     R8, [R15]
	MOV     R1, [R13+#020h]
	MOV     R2, [R13+#022h]
	MOV     R3, R8
	ADD     R8, #1
	ADD     R1, R3
	EXTS    R2, #1
	MOVB    RL6, [R1]
	MOV     R1, [R13+#024h]
	EXTS	#0, #1
	MOV	0FE0Eh, R8
	DIVU	R1
	EXTS	#0, #1
	MOV	R8, 0FE0Ch
	MOV     [R15], R8
	MOV     R13, [R14]
	SUB     R13, #1
	MOV     [R14], R13
	CMP     R12, #0
	JMPR    cc_NZ, hw_2
	BCLR	CLKOUT    ; RTSenable = true
hw_2:
	MOVB	RL1, RL6
	JMPR	cc_UC, hw_3
hw_1:
	MOVB	RL1, #0
hw_3:
	RETN
comget	endp

comsrec	proc near
_13:
	EXTS	#0, #1
	MOV	R14, 0F962h
	ADD	R14 ,R12
	CMP	R14, #0
	JMPR	cc_EQ, _12

	CMPD1	R5 ,#0
	JMPR	cc_Z,_14

	CALLR	comget

	EXTS	#8 ,#1
	MOVB	[R7], RL1
	ADD	R7, #1
	JMPR	cc_UC, _13
_14:
	ADD	R5, #1
_12:
	MOV	R12, R5
	CALLS	OSsegment,PUSH_R12
	RETN
comsrec	endp

hwrec	proc far
	CALLR	comdta
	MOV	R12,#0
	CALLR	comsrec
	POP R1
	POP R1
	RETS
hwrec	endp

hwreca	proc far
	CALLR	comadta
	MOV	R12,#0
	CALLR	comsrec
	POP R1
	POP R1
	RETS
hwreca	endp

swrec	proc far
	CALLR	comdta
	MOV	R12,#036h
	CALLR	comsrec
	POP R1
	POP R1
	RETS
swrec	endp

swreca	proc far
	CALLR	comadta
	MOV	R12,#036h
	CALLR	comsrec
	POP R1
	POP R1
	RETS
swreca	endp

comdta	proc near
	CALLS	OSsegment,POP_R4	; Length
	MOV	R5,R4
	CALLS	OSsegment,POP_R4	; Data-Buffer
	MOV	R7,R4
	RETN
comdta	endp

comadta	proc near
	CALLS	OSsegment,POP_R4	; Length
	MOV	R10,R4
	CALLS	OSsegment,POP_R4	; Data-Buffer / String
	ADD	R10,R4
	CALLS	OSsegment,POP_R4	; Pos
	MOV	R5,R4
	SUB	R10,R4
	MOV	R7,R10
	RETN
comadta	endp

;******************************************************
; mem.c2
;******************************************************
fill	proc far
 	CALLS	0, POP_R4	;value
	MOV	R2, R4
 	CALLS	0, POP_R4	;length
	MOV	R8, R4
 	CALLS	0, POP_R4	;start
	MOV	R9, R4
 	CALLS	0, POP_R4	;bufferaddress
        ADD	R4, R9
	
	CMP	R8, #0
	JMPR	cc_EQ, _2

	ADD	R8, R4
_1:
	EXTS	#8,#1
	MOVB	[R4], RL2
	ADD	R4,#1
	CMP	R4, R8
	JMPR	cc_ULT, _1
_2:
	POP	R1
	POP	R1
	RETS
fill	endp

copy	proc far
 	CALLS	0, POP_R4	;length
	MOV	R8, R4
	CALLS	0, POP_R4	;srcpos
	MOV	R3, R4
 	CALLS	0, POP_R4	;srcaddr
	ADD	R3, R4
 	CALLS	0, POP_R4	;destpos
	MOV	R2, R4
 	CALLS	0, POP_R4	;destaddr
	ADD	R4, R2
_3:
	CMPD1	R8, #0
	JMPR	cc_EQ, _4

	EXTS	#8,#1
	MOVB	RL1, [R3+]
	EXTS	#8,#1
	MOVB	[R4], RL1
	ADD	R4,#1
	JMPR	cc_UC, _3
_4:
	POP	R1
	POP	R1
	RETS
copy	endp


;******************************************************
;strx.c2
;******************************************************
comp	proc far
	MOV	R8, #30	;len
	MOV	R7, #0
	CALLR	compa
	POP	R1
	POP	R1
	RETS
comp	endp

compa	proc near
 	CALLS	0, POP_R4	;s2
	MOV	R2, R4
	CALLS	0, POP_R4	;s1
	ADD	R4, R7

	MOV	R12, #0FFFFh
_5:
	CMPD1	R8, #0
	JMPR	cc_EQ, _6

	EXTS	#8,#1
	MOVB	RL1, [R4+]
	EXTS	#8,#1
	MOVB	RH1, [R2+]
	CMPB	RL1, RH1
	JMPR	cc_EQ, _5
	MOV	R12, #00h
_6:
	CALLS	0,PUSH_R12
	RETN
compa	endp

compsel	proc far
 	CALLS	0, POP_R4	;s1pos
	MOV	R7, R4
	CALLS	0, POP_R4	;s2len
	MOV	R8, R4
	CALLR	compa
	POP	R1
	POP	R1
	RETS
compsel	endp

InStr_	proc far	
 	CALLS	0, POP_R4	;s2len
	MOV	R8, R4
 	CALLS	0, POP_R4	;s1len
	MOV	R7, R4
 	CALLS	0, POP_R4	;s2
	MOV	R3, R4
 	CALLS	0, POP_R4	;s1
	MOV	R2, R4
 	CALLS	0, POP_R4	;start
	MOV	R12, R7
	SUB	R12, R4
	CMP	R8, R12
	JMPR	cc_SGT, _i2

	MOV	R12, #0
	MOV	R5, R2
	ADD	R5, R4
	ADD	R7, R2
_i1:
	CMP	R5, R7
	JMPR	cc_EQ, _i2
	EXTS	#8,#1
	MOVB	RL1, [R5+]
	MOV	R13, R3
	ADD	R13, R12
	EXTS	#8,#1
	MOVB	RH1, [R13]
	CMPB	RL1, RH1
	JMPR	cc_NE, _i3
	ADD	R12, #1
	JMPR	cc_UC, _i4
_i3:
	MOV	R12, #0
_i4:
	CMP	R12, R8
	JMPR	cc_NE, _i1
	SUB	R5, R2
	SUB	R5, R8
	MOV	R12, R5
	JMPR	cc_UC, _i5
_i2:
	MOV	R12, #0FFFFh
_i5:
	CALLS	0,PUSH_R12
	POP	R1
	POP	R1
	RETS
InStr_	endp

ucec1	db	246
ucec2	db	252
ucec3	db	228
ucec4	db	233
ucase	proc far
	CALLR	casedta
_u1:
	CMP	R8, R2
	JMPR	cc_EQ, _u3
	MOVB	RL1, #97
	EXTS	#8,#1
	CMPB	RL1, [R2]
	JMPR	cc_UGT, _u1b
;	JMPR	cc_ULE, _u2
	MOVB	RL1, #122
	EXTS	#8,#1
	CMPB	RL1, [R2]
	JMPR	cc_UGE, _u2
;	JMPR	cc_ULE, _u2a
_u1b:	
	MOV	R12, #0
_u1a:	
	EXTS	#3,#1
	MOVB	RL1, [R12+#0E392h]
	EXTS	#8,#1
	CMPB	RL1, [R2]
	JMPR	cc_EQ, _u2

	CMPI1	R12, #3
	JMPR	cc_NE, _u1a
	JMPR	cc_UC, _u2a
_u2:	
	EXTS	#8,#1
	MOVB	RL7, [R2]
	SUBB	RL7, #32
	EXTS	#8,#1
	MOVB	[R2], RL7
_u2a:
	ADD	R2,#1      
	JMPR	cc_UC, _u1
_u3:
	POP	R1
	POP	R1
	RETS
ucase	endp	

casedta	proc near
 	CALLS	0, POP_R4	;len
	MOV	R8, R4
 	CALLS	0, POP_R4	;start
	MOV	R2, R4
 	CALLS	0, POP_R4	;s
	ADD	R2, R4
	ADD	R8, R4

	RETN
casedta	endp

lcec1	db	214
lcec2	db	220
lcec3	db	196
lcec4	db	201
lcase	proc far
	CALLR	casedta
_l1:
	CMP	R8, R2
	JMPR	cc_EQ, _l3
	MOVB	RL1, #65
	EXTS	#8,#1
	CMPB	RL1, [R2]
	JMPR	cc_UGT, _l1b
;	JMPR	cc_ULE, _l2
	MOVB	RL1, #90
	EXTS	#8,#1
	CMPB	RL1, [R2]
	JMPR	cc_UGE, _l2
;	JMPR	cc_ULE, _l2a
_l1b:	
	MOV	R12, #0
_l1a:	
	EXTS	#3,#1
	MOVB	RL1, [R12+#0E3FCh]
	EXTS	#8,#1
	CMPB	RL1, [R2]
	JMPR	cc_EQ, _l2

	CMPI1	R12, #3
	JMPR	cc_NE, _l1a
	JMPR	cc_UC, _l2a
_l2:	
	EXTS	#8,#1
	MOVB	RL7, [R2]
	ADDB	RL7, #32
	EXTS	#8,#1
	MOVB	[R2], RL7
_l2a:
	ADD	R2,#1      
	JMPR	cc_UC, _l1
_l3:
	POP	R1
	POP	R1
	RETS
lcase	endp	


left	proc far
	CALLR 	lrdata
	CALLR	cpy

	POP	R1
	POP	R1
	RETS
left	endp

lrdata	proc near
 	CALLS	0, POP_R4	;len
	MOV	R6, R4
 	CALLS	0, POP_R4	;dest
	MOV	R8, R4
 	CALLS	0, POP_R4	;src
	MOV	R3, #0
	MOV	R12, #31
	ADD	R12, R4
	EXTS	#8,#1
	MOVB	RL1, [R12]
	CMPB	RL6, RL1
	JMPR	cc_ULE, lr0
	EXTS	#8,#1
	MOVB	RL6, [R12]
lr0:
	RETN
lrdata	endp

cpy	proc near
cp1:
	CMPB	RL3, RL6
	JMPR	cc_EQ, cp2
	ADDB	RL3, #1
	EXTS	#8,#1
	MOVB	RL2, [R4+]
	EXTS	#8,#1
	MOVB	[R8], RL2
	ADD	R8, #1
	JMPR	cc_UC, cp1
cp2:
	MOV	R2, #0
cp3:
	CMPI1	R3, #31
	JMPR	cc_UGE, cp4
	EXTS	#8,#1
	MOVB	[R8], RL2
	ADD	R8, #1
	JMPR	cc_UC, cp3
cp4:
	EXTS	#8,#1
	MOVB	[R8], RL6

	RETN
cpy	endp

right	proc far
	CALLR	lrdata

	MOV	RH1, #0
	ADD	R4, R1
	SUB	R4, R6

	CALLR	cpy

	POP	R1
	POP	R1
	RETS
right	endp

mid	proc far
	CALLR	gssd
	ADD	R4, R7
	CALLR	cpy
	POP	R1
	POP	R1
	RETS
mid	endp

gssd	proc near
 	CALLS	0, POP_R4	;len
	MOV	R6, R4
 	CALLS	0, POP_R4	;start
	MOV	R7, R4
 	CALLS	0, POP_R4	;dest
	MOV	R8, R4
 	CALLS	0, POP_R4	;src
	MOV	R3, #0
	MOV	R12, #31
	ADD	R12, R4
	EXTS	#8,#1
	MOVB	RL1, [R12]
	CMPB	RL6, RL1
	JMPR	cc_ULE, gd0
	EXTS	#8,#1
	MOVB	RL6, [R12]
gd0:
	CMP	R7, #30
	JMPR	cc_ULE, gd1
	MOV	R7, #30
gd1:
	MOV	R2, R7
	ADD	R2, R6
	CMP	R2, #30
	JMPR	cc_ULE, gd2
	MOV	R6, #30
	SUB	R6, R7
gd2:
	RETN
gssd	endp

paste	proc far
	CALLR	gssd
	MOV	R1, R8
	ADD	R1, #31
	ADD	R8, R7
pa1:
	CMPB	RL3, RL6
	JMPR	cc_EQ, pa2
	ADDB	RL3, #1
	EXTS	#8,#1
	MOVB	RL2, [R4+]
	EXTS	#8,#1
	MOVB	[R8], RL2
	ADD	R8, #1
	JMPR	cc_UC, pa1
pa2:
	ADD	RL6, RL7
	EXTS	#8,#1
	MOVB	RL3, [R1]	
	CMPB	RL6, RL3
	JMPR	cc_ULE, pa3
	EXTS	#8,#1
	MOVB	[R1], RL6
pa3:
	POP	R1
	POP	R1
	RETS
paste	endp

cut	proc far
	CALLR	gssd
	ADD	R4, R7
	PUSH	R4
	CALLR	cpy
	POP	R4

	MOVB	RL5, RL1
	SUBB	RL5, RL6
	SUBB	RL5, RL7
	MOV	R3, #0
	MOV	R8, R6
	ADD	R8, R4
cu1:
	CMPB	RL3, RL5
	JMPR	cc_EQ, cu2
	ADDB	RL3, #1
	EXTS	#8,#1
	MOVB	RL2, [R8+]
	EXTS	#8,#1
	MOVB	[R4], RL2
	ADD	R4, #1
	JMPR	cc_UC, cu1
cu2:
	MOV	R2, #0
	SUB	R12, #1
cu3:
	CMP	R4, R12
	JMPR	cc_UGT, cu4
	EXTS	#8,#1
	MOVB	[R4], RL2
	ADD	R4, #1
	JMPR	cc_UC, cu3
cu4:
	ADDB	RL3, RL7
	EXTS	#8,#1
	MOVB	[R4], RL3

	POP	R1
	POP	R1
	RETS
cut	endp

split	proc far
 	CALLS	0, POP_R4	;searchfor
	MOVB	RL6, RL4
 	CALLS	0, POP_R4	;dest
	MOV	R8, R4
 	CALLS	0, POP_R4	;src
	MOV	R5, R4
	ADD	R5, #31
	EXTS	#8,#1
	MOVB	RL5,[R5]	;srclen
	MOVB	RH5, #0
	MOVB	RH6, #1
	MOV	R3, #0
	
sp1:	
	CMPB	RH5, RL5
	JMPR	cc_UGE, sp5
	ADDB	RH5, #1

	EXTS	#8,#1
	MOVB	RL7, [R4]

	CMPB	RL6, RL7
	JMPR	cc_EQ, sp2
	
	ADD	R3, #1
	EXTS	#8,#1
	MOVB	[R8], RL7
	ADD	R8, #1

	JMPR	cc_UC, sp4
sp2:
	CALLR	setStr
	MOV	R3, #0
	ADDB	RH6, #1
sp4:
	ADD	R4, #1	
	JMPR	cc_UC, sp1	
sp5:
	CALLR	setStr
	MOVBZ	R12, RH6
	CALLS	OSsegment,PUSH_R12

	POP	R1
	POP	R1
	RETS
split	endp

setStr	proc near
	MOV	R2, #0
	MOVB	RL7, RL3
st1:
	CMPI1	R3, #31
	JMPR	cc_UGE, st2
	EXTS	#8,#1
	MOVB	[R8], RL2
	ADD	R8, #1
	JMPR	cc_UC, st1
st2:
	EXTS	#8,#1
	MOVB	[R8], RL7
	ADD	R8, #1
	RETN
setStr	endp


replace	proc far
	CALLR	reppop

	CALLR	repsz

	CALLR	repl

	CALLS	OSsegment,PUSH_R12
	POP	R1
	POP	R1
	RETS
replace	endp


replen	proc far
	CALLR	reppop

 	CALLS	0, POP_R4	;len
	MOVB	RL6, RL4

	CALLR	repsz

 	CALLS	0, POP_R4	;start

	CMPB	RL4, RL6
	JMPR	cc_UGE, rn2
	SUBB	RL5, RL4
	ADD	R2, R4
	CMPB	RL5, RL6
	JMPR	cc_ULE, rn1
	MOVB	RL5, RL6
rn1:
	CALLR	repl
rn2:		
	CALLS	OSsegment,PUSH_R12

	POP	R1
	POP	R1
	RETS
replen	endp

reppop	proc near
 	CALLS	0, POP_R4	;newchar
	MOVB	RH3, RL4
 	CALLS	0, POP_R4	;findchar
	MOVB	RL3, RL4
	RETN
reppop	endp

repsz	proc near
 	CALLS	0, POP_R4	;string
	MOV	R2, R4
	MOV	R12, #0
	MOV	R5, #0
	EXTS	#8,#1
	MOVB	RL5, [R2+#31]
	RETN
repsz	endp

repl	proc near
rp1:
	CMPD1	R5, #0
	JMPR	cc_EQ, rp3

	EXTS	#8,#1
	MOVB	RL4, [R2]
	CMPB	RL4, RL3
	JMPR	cc_NE, rp2
	EXTS	#8,#1
	MOVB	[R2], RH3
	ADD	R12, #1
rp2:
	ADD	R2, #1	
	JMPR	cc_UC, rp1
rp3:
	RETN
repl	endp


userseg	ENDS
	END

